#!/usr/bin/perl

require "config.pl";

@months = ('01','02','03','04','05','06','07','08','09','10','11','12');
@days = ('','','','','','','');

if ($ENV{'REQUEST_METHOD'} eq "POST") { read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'}); }
else { $buffer=$ENV{'QUERY_STRING'}; }
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
 ($name, $value) = split(/=/, $pair);
 $name =~ tr/+/ /;
 $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
 $name =~ s/<([^>]|\n)*>//g; #
 $name =~ s/<!--(.|\n)*-->//g; #
 $name =~ s/  / /g;
 $name =~ s/^\s+//;  #    
 $name =~ s/::/:\;/g;
 $value =~ tr/+/ /;
 $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
 $value =~ s/<([^>]|\n)*>//g; #
 $value =~ s/<!--(.|\n)*-->//g; #
 $value =~ s/  / /g;
 $value =~ s/^\s+//;  #    
 $value =~ s/::/:\;/g;
 $FORM{$name} = $value;
}
$action=$FORM{action};
$page=$FORM{page};
&html;

open(GB, "$filename");
@DATA=<GB>;
close (GB);
$allmess = @DATA;
$pageend=$page+$mess-1;

if ($action eq "add") { &add; }

&forma;
&show;
&glos;
&htmlend;
exit;

sub razbor {
 my $txt=@_[0];
 my @words=split (/ /,$txt);
 foreach $word (@words) {
  if (length($word)>30) { &error (2); }
 }
}

sub checkbadwords {
 my $text = shift;
 $text = &lettersonly (&lcr($text));
 foreach (@bad_words) { # 
  my $word = &lettersonly (&lcr($_));
  my $ind = index ($text, $word);
  if ($ind > -1) { return 1; }
 }
 return 0; 
}

sub add  {
 ($sec,$min,$hour,$mday,$mon,$year,$wday) = localtime(time);
 if ($year<1901) { $year+=1900; }
 if ($hour<10) { $hour="0$hour"; }
 if ($min<10) { $min="0$min"; }
 if ($mday<10) { $mday="0$mday"; }

 my $ip=$ENV{'REMOTE_ADDR'};
 @banned=&readfile ("$banname");
 foreach $ban (@banned) {
  chomp $ban;
  if ("$ban" eq "$ip") {
   &error (5);
  }
 }

 $pdata="[$days[$wday], $mday/$months[$mon]/$year, $hour:$min, $ip]";
 $name=$FORM{name};
 if ($name eq "") { &error (1); }
 else { &razbor ($name); }
 $text=$FORM{text};

 $text =~ s/\r\n/ /g;
 $text =~ s/\n/ /g;

 if ($text eq "") { &error (1); }
 else { &razbor ($text); }
 if ($FORM{mail} ne "") { $mail=$FORM{mail}; }
 else { $mail="0"; }
 if ($FORM{url} ne "") { $url=$FORM{url}; }
 else { $url="0"; }
 if ($FORM{city} ne "") { $city=$FORM{city}; }
 else { $city="0"; }
                   
 if ( (length($name)>$maxlength) or (length($mail)>$maxlength) or
      (length($url)>$maxlength) or (length($city)>$maxlength) or
      (length($text)>$msglength) ) { &error (4); }

 if ( (&checkbadwords ($text) == 1) || (&checkbadwords ($name) == 1) ||
  (&checkbadwords ($url) == 1) || (&checkbadwords ($city) == 1) ||
  (&checkbadwords ($mail) == 1)) { &error (6); }

 my $code = $FORM{code};
 my $code2 = $FORM{code2};
 if ("$code" ne "$code2") {
  &error (7);
 }

 $STRING = join("::",$name,$mail,$url,$pdata,$city,$text,"0");
 open(GB, "+<$filename") || open(GB, ">$filename");
 @DATA=<GB>;
 #  
 my ($name2,$mail2,$url2,$time2,$city2,$text2,$answer2) = split(/::/,$DATA[0]);
 if ("$text" eq "$text2") { &error (3); }

 @DATA=("$STRING\n",@DATA);
 seek(GB,0,0);
 flock (GB,2);
 print GB @DATA;
 flock (GB,8);
 close (GB);
 $allmess++;
}

sub getcode {
 srand (time); 
 my $symbols="123456789abcdefghijklmnopqrstuvwxyz"; 
 my $code = "";
 my $len=length($symbols);
 for ($i=0; $i<4; $i++) {
  $code.=substr($symbols,int(rand($len)),1);
 } 
 return $code;
}

sub tagcode {
 my $code=@_[0];
 my @tags = ( "sup","sub","big","small","u","b","i" );
 my $str="<font size=+1>";
 my $t=0;
 for ($i=0; $i<4; $i++) {
  $t=int(rand($#tags));
  $str.= '<'.$tags[$t].'>'.substr($code,$i,1).'</'.$tags[$t].'>';
 }
 $str.="</font>";
 return $str;
}

sub forma {
 my $code = &getcode;
 my $code2= &tagcode ($code);
 print <<FORMA;
<table border=0 cellpadding=0 cellspacing=0 width=100%>
<tr><td colspan="2"><p><font class="letter"></font>      
.      - 
<font class="name"></font>, <font class="name"></font>
 <font class="name"> </font>   ! ,   
      . 
    "<a href="#" onClick="window.open('/images/gbook/smiles.html','','toolbar=no,scrollbars=yes,directories=no,status=no,menubar=no,resizable=no,width=600,height=400')"></a>".</p>
<p><small>   "", "E-mail", " ", "" - $maxlength ,  "" - $msglength .</small></p></td></tr>
 <form method="POST" action="index.pl">
 <input type="hidden" name="action" value=add>
 <input type="hidden" name="page" value=0>
 <input type="hidden" name="code" value=$code>
 <tr><td align=right><p><font class="name"></font>: </td><td><input type="text" size="40" name="name" value=\"$name\" class=button maxlength=$namelength></td></tr>
 <tr><td align=right><p> E-mail: </td><td><input type="text" size="40" class=button name="mail"  value=\"$mail\" maxlength=$namelength></td></tr>
 <tr><td align=right><p>  (): </td><td><input type="text" size="40" class=button name="url"  value=\"$url\" maxlength=$namelength></td></tr>
 <tr><td align=right><p>: </td><td><input type="text" size="40" class=button name="city"  value=\"$city\" maxlength=$namelength></td></tr>
 <tr><td align=right valign=top><p><font class="name"></font>: </td><td><textarea name="text" class=button style="overflow:hidden" rows="4" cols="45" maxlength=$msglength wrap=virtual>$text</textarea></td></tr>
 <tr><td align=right><p><font class="name"> </font> ($code2): </td><td><input type="text" size="6" name="code2" value="" class=button maxlength=6></td></tr>
 <tr><td align=right><input type="submit" name="b1" class="button" value="">&nbsp;</td>
 <td><input type="reset" name="b2" class="button" value=""></td></tr>
 </form></table></center><br><br>
FORMA
}

sub smiles {
 my $text=@_[0];
 open(SMILE, "smiles.txt");
 @sm=<SMILE>;
 close (SMILE);
 foreach $line (@sm) {
  ($from, $to) = split(/\t/, $line);
  $len=length($from);
  do {
   $ind=index ($text, $from);
   if ($ind>-1) {
    $s1=substr ($text,0,$ind);
    $s2=substr($text,$ind+$len);
    $text="$s1$to$s2";
   }
  } while ($ind!=-1);
 }
 return $text;
}

sub show {
 print "<center><table border=0 cellpadding=0 cellspacing=0 width=100%>";
 for($i=$page;$i<=$pageend;$i++) {
  ($name,$mail,$url,$tim,$city,$text2,$answer) = split(/::/,$DATA[$i]);
  if($name ne "") {
   print "<tr><td align=left><font size=3 face=Tahoma><p><b>$name</b>";
   if($city ne "0") { print " ($city)"; }
   print "</font></p>";
   if ($mail ne "0") {
    print "<p><a href=\"mailto:$mail\"><font size=2 >$mail</font></a></p>";
   }
   if($url ne "0") {
    print "<p><a href=\"$url\"><font size=2>$url</font></p>";
   }
   $text2=&smiles ($text2);
   print "</td></tr><tr><td><p>$text2</p></td></tr><tr><td align=right><font size=2 face=Tahoma>$tim</td></tr>";
   if($answer ne "0\n") {
    $answer = &smiles ($answer);
    print "<tr><td><p><b></b>: $answer</p></td></tr>";
   }
   print "<tr><td><hr width=100% size=1 noshade color=#59c0e9></font></td></tr>";
  }
 }
 print "</table></center>";
}

sub glos {
 print "<center>";
 $all = int($allmess / $mess)+1;
 print "| ";
 for($i=1;$i <= $all;$i++) {
  $to=$i*$mess-$mess;
  $a=$page/10+1;
#  if($a ne $i) { 
  print " <a href=index.pl?page=$to>$i</a> |"; 
# } else { print " $i |";}
 }
 print "</center>";
}

sub html {
 print "Content-type: text/html\n\n";
 open (HEADER,"$filehdr");
 while (<HEADER>) { print "$_"; }
 close (HEADER);
}

sub htmlend {
 print "<center><br>  - $allmess</center>";
 open (SOF,"$fileend");
 while (<SOF>) { print "$_"; }
 close (SOF);
}

sub error {
 my $num=@_[0];
 print "<p>&nbsp;</p><p><b>   .  :</b></p>";
 if ($num eq '1') { print "<p><b>: \"\"  \"\"   .</b></p>"; }
 elsif ($num eq '2') { print "<p><b>     30 .</b></p>"; }
 elsif ($num eq '3') { print "<p><b>   .</b></p>"; }
 elsif ($num eq '4') { print "<p><b>    .</b></p>"; }
 elsif ($num eq '5') { print "<p><b> IP- .   .</b></p>"; }
 elsif ($num eq '6') { print "<p><b>   </b></p>"; }
 elsif ($num eq '7') { print "<p><b>      </b></p>"; }
 print "<p>&nbsp;</p>";
 &forma;
 &show;
 &glos;
 &htmlend;
 exit;
}
